<?php

namespace Teknisa\ACL\Controllers;

use Teknisa\ACL\Controllers\TeknisaCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;

class PerfilAcessParcController extends TeknisaCrud
{
    protected $dataSourceName = "perfacessparcCompleto";
    protected $newCode;

    public function __construct ($crudService, $parameterBag, $entityManager, $newCode)
    {
    
        $this->entityManager = $entityManager;
        $this->newCode = $newCode;

        parent::__construct($crudService, $parameterBag);
    }

    public function save(DTO\Request $request, DTO\Response $response)
    {
        try
        {
            $cont = 0;
            foreach($request->getDataSet()->getRows() as $row)
            {
                if(!\Zeedhi\Framework\Util\Functions::arrayKeyExists('DTVALPERFILPARC', $row)){
                    $row['DTVALPERFILPARC'] = "";
                }
                if($row["__is_new"])
                {
                	$row["NRPERFACESSPARC"] = self::getMaxPerfCode($row)+$cont;
                	parent::save($request, $response);
                }
                else
                {
                    parent::save($request, $response);
                }
                $cont++;
            }
        }catch(\Exception $e)
        {
            var_dump($e->getMessage());
        }
    }
    
    public function getMaxPerfCode($row){
        $select = "SELECT MAX(NRPERFACESSPARC)MAX_ID FROM PERFACESSPARC WHERE NRORG =:NRORG";
        $params = array('NRORG' => $row['NRORG'] );
        try
        {
            $std = $this->entityManager->getConnection()->prepare($select);
            $std->execute($params);
            $result = $std->fetchAll();
            return $result[0]["MAX_ID"]+1;
        }
        catch(\Exception $e)
        {
            throw new \Exception($e->getMessage());
        };
    }
}