<?php
namespace Teknisa\ACL\Util\Instance;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DependencyInjection\InstanceManager;
use Teknisa\ACL\Util\InstanceProvider;
use Teknisa\ACL\Util\AclUtilities;
use Teknisa\Model\Geral;

class Repository {

    /** @return  Repository */
    public static function getInstance()
    {
        return new static();
    }

    /** @return  \Teknisa\Acl\Repositories\Operator */
    public function getOperator()
    {
        return InstanceManager::getInstance()->getService('operatorRepository');
    }
    
    /** @return  \Teknisa\Acl\Repositories\AclParamgeral */
    public function getAclParamgeral()
    {
        return InstanceManager::getInstance()->getService('AclParamgeralRepository');
    }

    /** @return  \Teknisa\Acl\Repositories\SqlLogs */
    public function getSqlLogsRepository()
    {
        return InstanceManager::getInstance()->getService('sqlLogsRepository');
    }

    /** @return  \Teknisa\Acl\Repositories\Crud */
    public function getCrud()
    {
        return InstanceManager::getInstance()->getService('crudRepository');
    }

    /** @return  \Teknisa\Libs\Util\Repositories\UserData */
    public function getLibUserData()
    {
        return InstanceManager::getInstance()->getService('libUserDataRepository');
    }

    /** @return Geral\Repositories\Paramsenha */
    public static function getParamSenha()
    {
        return InstanceProvider::getEntityManager()->getRepository(AclUtilities::GERAL_ENTITY_DIR . 'Paramsenha');
    }

    /** @return Geral\Repositories\Controlsenha */
    public static function getControlSenha()
    {
        return InstanceProvider::getEntityManager()->getRepository(AclUtilities::GERAL_ENTITY_DIR . 'Controlsenha');
    }

    /**
     * @return  \Teknisa\Acl\Repositories\OAccTekMgr
     * @throws \Exception
     */
    public function getOAccTekMgr()
    {
        return InstanceManager::getInstance()->getService('oacctekmgrRepository');
    }

    /** @return  \Teknisa\Acl\Repositories\Organization
     * @throws \Exception
     */
    public function getOrganization()
    {
        return InstanceManager::getInstance()->getService('organizationRepository');
    }

    /** @return  \Teknisa\Acl\Repositories\PerfAcessParc */
    public function getPerfAcessParc()
    {
        return InstanceManager::getInstance()->getService('perfAcessParcRepository');
    }

    /** @return  \Teknisa\Acl\Repositories\ParcNegocio */
    public function getparcNegocio()
    {
        return InstanceManager::getInstance()->getService('parcNegocioRepository');
    }
    
    /** @return  \Teknisa\Acl\Repositories\GrupoOperador */
    public function getGrupoOperador()
    {
        return InstanceManager::getInstance()->getService('GrupoOperadorRepository');
    }
    

    

}